unit Unit2;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, LResources, Forms, Controls, Graphics, Dialogs, StdCtrls;

type
  TTestComp = class(TCustomControl)
  private
     FButton : TButton;
     FOldHeight : Integer;
  public
     constructor Create(AOwner: TComponent); override;
     destructor Destroy; override;
     procedure Paint; override;
     procedure AlignControls(AControl: TControl;
         var RemainingClientRect: TRect); override;
     procedure ChangeBounds(ALeft, ATop, AWidth, AHeight: integer); override;
     procedure OnButtonClick(Sender: TObject);
  end;

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    Memo1: TMemo;
    procedure FormClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    { private declarations }
  public
    TestComp1 : TTestComp;
    { public declarations }
  end; 

var
  Form1: TForm1; 

implementation

constructor TTestComp.Create(AOwner: TComponent);
begin
    Inherited;
    
    FButton := TButton.Create(Self);
    FButton.Left:=0;
    FButton.Top:=0;
    FButton.Parent:=Self;
    FButton.OnClick:=@OnButtonClick;
end;

destructor TTestComp.Destroy;
begin
    FButton.Free;
    
    Inherited;
end;

procedure TTestComp.OnButtonClick(Sender: TObject);
begin
    if FButton.Height = Height then
       Height := FOldHeight
    else begin
        FOldHeight:=Height;
        Height:=FButton.Height;
    end;

end;

procedure TTestComp.Paint;
var
   i,j : Integer;
begin
    {for i := 0 to Width do
     for j := 0 to FButton.Height do
       Canvas.Pixels[i,j]:= FButton.GetBackground.Pixels[i,j];
    }
    Inherited;
end;

procedure TTestComp.AlignControls(AControl: TControl;
         var RemainingClientRect: TRect);
begin
    RemainingClientRect := Rect(0,FButton.Height,Width,Height);
    
    Inherited;
end;

procedure TTestComp.ChangeBounds(ALeft, ATop, AWidth, AHeight: integer);
begin
    Inherited;
    
    FButton.Width:=AWidth;
end;

{ TForm1 }

procedure TForm1.FormCreate(Sender: TObject);
begin
  TestComp1 := TTestComp.Create(Self);
  with TestComp1 do
  begin
      Width:=100;
      Height:=150;
      Parent:= Self;
  end;
  
  Memo1.Parent:=TestComp1;
  Button1.Parent:= TestComp1;
  //Memo1.Align:=alClient;
end;

procedure TForm1.FormClick(Sender: TObject);
begin

end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  TestComp1.Free;
end;

initialization
  {$I unit2.lrs}

end.

